## nqc 2.0.2

=== Makefile ===
# Makefile for nqc
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.0 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
# The Initial Developer of this code is David Baum.
# Portions created by David Baum are Copyright (C) 1999 David Baum.
# All Rights Reserved.
#
#   original author:
#		Dave Baum <dbaum@enteract.com>
#
#   other contributors:
#		Rodd Zurcher <rbz@enteract.com>
#		Patrick Nadeau <pnadeau@wave.home.com>
#
#
.SUFFIXES: .cpp .c

#
# Pick your C++ compiler. 
#
CC=g++
#CC=gcc

#
# Pick your YACC processor
#
YACC = bison -y
# YACC = yacc

#
# Define the FLEX processor
#    note - lex will not work
#
FLEX = flex

#
# Use this to define the default device driver name
# for serial port connections.
#
DEFAULT_SERIAL_NAME = "/dev/ttyS0"


# other commands
LD=$(CC)
CP=cp -f
MKDIR=mkdir
MV=mv -f
RM=rm -f

IFLAGS=-Iplatform -Ircxlib -Inqc -Icompiler
WFLAGS=-Wall -Wstrict-prototypes -Wmissing-prototypes
CFLAGS = -O6 -pipe $(IFLAGS) $(WFLAGS) -DDEFAULT_SERIAL_NAME='$(DEFAULT_SERIAL_NAME)'

OBJ = $(NQCOBJ) $(COBJ) $(RCXOBJ) $(POBJ)

RCXOBJ= rcxlib/RCX_Cmd.o rcxlib/RCX_Disasm.o rcxlib/RCX_Image.o \
	rcxlib/RCX_Link.o rcxlib/RCX_Log.o 

POBJ=	platform/PArray.o platform/PStream.o platform/PSerial_unix.o \
	platform/PHashTable.o platform/PListS.o

COBJ=	compiler/AsmStmt.o compiler/AssignStmt.o compiler/BlockStmt.o compiler/Bytecode.o \
	compiler/Condition.o compiler/Conditional.o compiler/CondParser.o compiler/DoStmt.o \
	compiler/Expansion.o compiler/Fragment.o compiler/IfStmt.o compiler/JumpStmt.o \
	compiler/lexer.o compiler/Macro.o compiler/parse.o \
	compiler/PreProc.o compiler/Program.o compiler/RepeatStmt.o compiler/ReturnStmt.o \
	compiler/Stmt.o compiler/Symbol.o compiler/TaskStmt.o compiler/WhileStmt.o compiler/Error.o \
	compiler/AutoFree.o compiler/parse_util.o compiler/Expr.o \
	compiler/GosubStmt.o compiler/Scope.o compiler/InlineStmt.o compiler/CallStmt.o \
	compiler/Compiler.o compiler/Buffer.o compiler/Mapping.o compiler/VarPool.o \
	compiler/Function.o compiler/ExprStmt.o compiler/AtomExpr.o compiler/IncDecExpr.o \
	compiler/BinaryExpr.o compiler/UnaryExpr.o compiler/ValueExpr.o

NQCOBJ = nqc/nqc.o nqc/SRecord.o nqc/DirList.o

# We need a 'bin' directory because the names of the binaries clash
# with existing directory names.

all : bin nqh bin/nqc

# Create the bin directory in the Makefile because it is not part
# of the original distribution.  This prevents the need to tell the user
# to do it.

bin:
	$(MKDIR) bin

bin/nqc : compiler/parse.cpp $(OBJ)
	$(LD) -o $@ $(OBJ)

bin/mkdata : mkdata/mkdata.c bin
	$(LD) -o bin/mkdata mkdata/mkdata.c

#
# clean up stuff
#
clean: clean-parser clean-lexer clean-obj clean-nqh

clean-obj:
	$(RM) bin/*
	$(RM) */*.o


clean-parser:
	$(RM) compiler/parse.cpp compiler/parse.tab.h

clean-lexer:
	$(RM) compiler/lexer.cpp

clean-nqh:
	$(RM) compiler/rcx1_nqh.h compiler/rcx2_nqh.h
#
# create the parser files (parse.cpp and parse.tab.h)
#
compiler/parse.cpp: compiler/parse.y
	(cd compiler ; $(YACC) -d parse.y ; \
	$(MV) y.tab.c parse.cpp ; $(MV) y.tab.h parse.tab.h )

#
# create the lexer file (lexer.cpp)
#
compiler/lexer.cpp: compiler/lex.l
	(cd compiler ; $(FLEX) lex.l )

#
# NQH files
#
nqh : compiler/rcx1_nqh.h compiler/rcx2_nqh.h

compiler/rcx1_nqh.h: compiler/rcx1.nqh bin/mkdata
	bin/mkdata compiler/rcx1.nqh compiler/rcx1_nqh.h rcx1_nqh

compiler/rcx2_nqh.h: compiler/rcx2.nqh bin/mkdata
	bin/mkdata compiler/rcx2.nqh compiler/rcx2_nqh.h rcx2_nqh

#
# general rule for compiling
#
.cpp.o:
	$(CC) -c $(CFLAGS) $< -o $*.o 


#
# Use these targets to use the default parser/lexer files.  This is handy if
# your system does not have a suitable flex and/or yacc tool.
#
default-parser:
	$(CP) default/parse.cpp default/parse.tab.h nqcc

default-lexer:
	$(CP) default/lexer.cpp nqcc


#
# This is used to create a default parser and lexer for later use.  You shouldn't need
# to do this as part of the port.
#
default-snapshot: default compiler/parse.cpp compiler/lexer.cpp
	$(CP) compiler/parse.cpp compiler/parse.tab.h compiler/lexer.cpp default

default:
	$(MKDIR) default

## nqc 2.5.r3

=== Makefile ===
# Makefile for nqc
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.0 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
# The Initial Developer of this code is David Baum.
# Portions created by David Baum are Copyright (C) 1999 David Baum.
# All Rights Reserved.
#
#   original author:
#		Dave Baum <dbaum@enteract.com>
#
#   other contributors:
#		Rodd Zurcher <rbz@enteract.com>
#		Patrick Nadeau <pnadeau@wave.home.com>
#		Jonathan W. Miner <jminer@fcmail.com>
#
#
.SUFFIXES: .cpp .c

#
# Pick your C++ compiler. 
#
CC=g++
# CC=gcc

#
# Pick your YACC processor
#
YACC = bison -y
# YACC = yacc

#
# Define the FLEX processor
#    note - lex will not work
#
FLEX = flex

# Link in any necessary C++ libraries
#
LIBS = -lstdc++



# installation information
BINDIR=/usr/local/bin
MANDIR=/usr/local/man/man1
MANEXT=1


# other commands
CP=cp -f
MKDIR=mkdir
MV=mv -f
RM=rm -f

# CFLAGS
CFLAGS = -pipe -Iplatform -Ircxlib -Inqc -Icompiler -Wall -Wstrict-prototypes -Wmissing-prototypes

USBOBJ = rcxlib/RCX_USBTowerPipe_none.o

	
#
# Platform specific tweaks
#
OSTYPE := $(strip $(shell uname -s))

ifneq (,$(strip $(findstring $(OSTYPE), Darwin)))
  # Mac OSX
  LIBS += -framework IOKit -framework CoreFoundation
  USBOBJ = rcxlib/RCX_USBTowerPipe_osx.o
  CC = c++
else
ifneq (,$(strip $(findstring $(OSTYPE), Linux)))
  # Linux
  USBOBJ = rcxlib/RCX_USBTowerPipe_linux.o
  CFLAGS += -I/usr/local/include/LegoUSB -Wno-deprecated
else
ifneq (,$(findstring $(OSTYPE), SunOS))
  # Solaris
  CFLAGS += -DSOLARIS
else
  # default Unix build without USB support
  CFLAGS += -O6
endif
endif
endif


# this must happen after the platform tweaks just in case the platform
# wants to redefine the default serial name
#
ifndef DEFAULT_SERIAL_NAME
  DEFAULT_SERIAL_NAME = "/dev/ttyS0"
endif
CFLAGS += -DDEFAULT_SERIAL_NAME='$(DEFAULT_SERIAL_NAME)'

#
# Object files
#
OBJ = $(NQCOBJ) $(COBJ) $(RCXOBJ) $(POBJ)

RCXOBJ= rcxlib/RCX_Cmd.o rcxlib/RCX_Disasm.o rcxlib/RCX_Image.o \
	rcxlib/RCX_Link.o rcxlib/RCX_Log.o rcxlib/RCX_Target.o \
	rcxlib/RCX_PipeTransport.o rcxlib/RCX_Transport.o \
	rcxlib/RCX_SpyboticsLinker.o rcxlib/RCX_SerialPipe.o \
	$(USBOBJ)

POBJ= platform/PStream.o platform/PSerial_unix.o \
	platform/PHashTable.o platform/PListS.o

COBJ=	compiler/AsmStmt.o compiler/AssignStmt.o compiler/BlockStmt.o compiler/Bytecode.o \
	compiler/Conditional.o compiler/CondParser.o compiler/DoStmt.o \
	compiler/Expansion.o compiler/Fragment.o compiler/IfStmt.o compiler/JumpStmt.o \
	compiler/lexer.o compiler/Macro.o compiler/parse.o \
	compiler/PreProc.o compiler/Program.o compiler/RepeatStmt.o compiler/AssignMathStmt.o \
	compiler/Stmt.o compiler/Symbol.o compiler/TaskStmt.o compiler/WhileStmt.o compiler/Error.o \
	compiler/AutoFree.o compiler/parse_util.o compiler/Expr.o \
	compiler/GosubStmt.o compiler/Scope.o compiler/InlineStmt.o compiler/CallStmt.o \
	compiler/CaseStmt.o compiler/SwitchStmt.o compiler/MonitorStmt.o compiler/AcquireStmt.o \
	compiler/DeclareStmt.o compiler/ScopeStmt.o compiler/ForStmt.o compiler/CatchStmt.o\
	compiler/LabelStmt.o compiler/GotoStmt.o \
	compiler/Compiler.o compiler/Buffer.o compiler/Mapping.o \
	compiler/FunctionDef.o compiler/ExprStmt.o compiler/AtomExpr.o compiler/IncDecExpr.o \
	compiler/BinaryExpr.o compiler/UnaryExpr.o compiler/ValueExpr.o compiler/TypeExpr.o \
	compiler/ModExpr.o compiler/EventSrcExpr.o compiler/SensorExpr.o \
	compiler/ArrayExpr.o compiler/TaskIdExpr.o compiler/RelExpr.o compiler/LogicalExpr.o \
	compiler/NegateExpr.o compiler/IndirectExpr.o compiler/NodeExpr.o compiler/ShiftExpr.o compiler/TernaryExpr.o \
	compiler/VarAllocator.o compiler/VarTranslator.o compiler/Resource.o

NQCOBJ = nqc/nqc.o nqc/SRecord.o nqc/DirList.o nqc/CmdLine.o

# We need a 'bin' directory because the names of the binaries clash
# with existing directory names.

all : bin nqh nub bin/nqc

# Create the bin directory in the Makefile because it is not part
# of the original distribution.  This prevents the need to tell the user
# to do it.

bin:
	$(MKDIR) bin

bin/nqc : compiler/parse.cpp $(OBJ)
	$(CC) -o $@ $(OBJ) $(LIBS)

bin/mkdata : mkdata/mkdata.cpp nqc/SRecord.cpp
	$(CC) -o bin/mkdata -Inqc/ -Iplatform/ mkdata/mkdata.cpp nqc/SRecord.cpp

#
# clean up stuff
#
clean: clean-parser clean-lexer clean-obj clean-nqh clean-nub

clean-obj:
	$(RM) bin/*
	$(RM) */*.o


clean-parser:
	$(RM) compiler/parse.cpp compiler/parse.tab.h

clean-lexer:
	$(RM) compiler/lexer.cpp

clean-nqh:
	$(RM) compiler/rcx1_nqh.h compiler/rcx2_nqh.h

clean-nub:
	$(RM) rcxlib/rcxnub.h

#
# create the parser files (parse.cpp and parse.tab.h)
#
compiler/parse.cpp: compiler/parse.y
	(cd compiler ; $(YACC) -d parse.y ; \
	$(MV) y.tab.c parse.cpp ; $(MV) y.tab.h parse.tab.h )

#
# create the lexer file (lexer.cpp)
#
compiler/lexer.cpp: compiler/lex.l
	(cd compiler ; $(FLEX) lex.l )

#
# NQH files
#
nqh : compiler/rcx1_nqh.h compiler/rcx2_nqh.h

compiler/rcx1_nqh.h: compiler/rcx1.nqh bin/mkdata
	bin/mkdata compiler/rcx1.nqh compiler/rcx1_nqh.h rcx1_nqh

compiler/rcx2_nqh.h: compiler/rcx2.nqh bin/mkdata
	bin/mkdata compiler/rcx2.nqh compiler/rcx2_nqh.h rcx2_nqh

#
# rcxnub.h
#
nub: rcxlib/rcxnub.h

rcxlib/rcxnub.h: rcxlib/fastdl.srec bin/mkdata
	bin/mkdata -s rcxlib/fastdl.srec rcxlib/rcxnub.h rcxnub

#
# general rule for compiling
#
.cpp.o:
	$(CC) -c $(CFLAGS) $< -o $*.o 


#
# Use these targets to use the default parser/lexer files.  This is handy if
# your system does not have a suitable flex and/or yacc tool.
#
default-parser:
	$(CP) default/parse.cpp default/parse.tab.h nqc

default-lexer:
	$(CP) default/lexer.cpp nqc


#
# This is used to create a default parser, lexer, and nqh files for later use. 
# You shouldn't need to do this as part of a port.
#
DEF_FILES = compiler/parse.cpp compiler/lexer.cpp compiler/rcx1_nqh.h compiler/rcx2_nqh.h
default-snapshot: default $(DEF_FILES)
	$(CP) $(DEF_FILES) compiler/parse.tab.h default

default:
	$(MKDIR) default

#
# Installation of binary and man page
#
install: all
	test -d $(BINDIR) || mkdir -p $(BINDIR)
	cp -r bin/* $(BINDIR)
	test -d $(MANDIR)  || mkdir -p $(MANDIR)
	cp nqc-man-2.1r1-0.man $(MANDIR)/nqc.$(MANEXT)

## nqc 3.1.r6

=== Makefile ===
--- 
+++ 
@@ -14,6 +14,9 @@
 # Portions created by David Baum are Copyright (C) 1999 David Baum.
 # All Rights Reserved.
 #
+# Portions created by John Hansen are Copyright (C) 2005 John Hansen.
+# All Rights Reserved.
+#
 #   original author:
 #		Dave Baum <dbaum@enteract.com>
 #
@@ -26,47 +29,49 @@
 .SUFFIXES: .cpp .c
 
 #
-# Pick your C++ compiler. 
-#
-CC=g++
-# CC=gcc
+# Pick your C++ compiler.
+#
+CXX ?= ${CXX}
+# CXX ?= gcc
 
 #
 # Pick your YACC processor
 #
-YACC = bison -y
-# YACC = yacc
+YACC ?= bison -y
+# YACC ?= yacc
 
 #
 # Define the FLEX processor
 #    note - lex will not work
 #
-FLEX = flex
+FLEX ?= flex
 
 # Link in any necessary C++ libraries
 #
-LIBS = -lstdc++
+LIBS ?= -lstdc++
 
 
 
 # installation information
-BINDIR=/usr/local/bin
-MANDIR=/usr/local/man/man1
-MANEXT=1
+PREFIX?=/usr/local
+BINDIR?=${PREFIX}/bin
+MANDIR?=${PREFIX}/man/man1
+MANEXT?=1
 
 
 # other commands
-CP=cp -f
-MKDIR=mkdir
-MV=mv -f
-RM=rm -f
+CP?=cp -f
+MKDIR?=mkdir
+MV?=mv -f
+RM?=rm -f
 
 # CFLAGS
-CFLAGS = -pipe -Iplatform -Ircxlib -Inqc -Icompiler -Wall -Wstrict-prototypes -Wmissing-prototypes
+#CFLAGS = -pipe -Iplatform -Ircxlib -Inqc -Icompiler -Wall -Wstrict-prototypes -Wmissing-prototypes
+CFLAGS += -Iplatform -Ircxlib -Inqc -Icompiler -Wall
 
 USBOBJ = rcxlib/RCX_USBTowerPipe_none.o
 
-	
+
 #
 # Platform specific tweaks
 #
@@ -76,22 +81,30 @@
   # Mac OSX
   LIBS += -framework IOKit -framework CoreFoundation
   USBOBJ = rcxlib/RCX_USBTowerPipe_osx.o
-  CC = c++
+  CXX = c++
 else
 ifneq (,$(strip $(findstring $(OSTYPE), Linux)))
   # Linux
-  USBOBJ = rcxlib/RCX_USBTowerPipe_linux.o
+# uncomment this next line if you have the USB tower library installed
+#  USBOBJ = rcxlib/RCX_USBTowerPipe_linux.o
   CFLAGS += -I/usr/local/include/LegoUSB -Wno-deprecated
 else
 ifneq (,$(findstring $(OSTYPE), SunOS))
   # Solaris
   CFLAGS += -DSOLARIS
 else
+ifneq (,$(strip $(findstring $(OSTYPE), FreeBSD)))
+  # FreeBSD
+  USBOBJ = rcxlib/RCX_USBTowerPipe_fbsd.o
+  DEFAULT_SERIAL_NAME = "/dev/cuad0"
+  CFLAGS += -Wno-deprecated
+else
   # default Unix build without USB support
   CFLAGS += -O6
 endif
 endif
 endif
+endif
 
 
 # this must happen after the platform tweaks just in case the platform
@@ -109,7 +122,7 @@
 
 RCXOBJ= rcxlib/RCX_Cmd.o rcxlib/RCX_Disasm.o rcxlib/RCX_Image.o \
 	rcxlib/RCX_Link.o rcxlib/RCX_Log.o rcxlib/RCX_Target.o \
-	rcxlib/RCX_PipeTransport.o rcxlib/RCX_Transport.o \
+	rcxlib/RCX_Pipe.o rcxlib/RCX_PipeTransport.o rcxlib/RCX_Transport.o \
 	rcxlib/RCX_SpyboticsLinker.o rcxlib/RCX_SerialPipe.o \
 	$(USBOBJ)
 
@@ -133,7 +146,8 @@
 	compiler/ModExpr.o compiler/EventSrcExpr.o compiler/SensorExpr.o \
 	compiler/ArrayExpr.o compiler/TaskIdExpr.o compiler/RelExpr.o compiler/LogicalExpr.o \
 	compiler/NegateExpr.o compiler/IndirectExpr.o compiler/NodeExpr.o compiler/ShiftExpr.o compiler/TernaryExpr.o \
-	compiler/VarAllocator.o compiler/VarTranslator.o compiler/Resource.o
+	compiler/VarAllocator.o compiler/VarTranslator.o compiler/Resource.o \
+	compiler/AddrOfExpr.o compiler/DerefExpr.o compiler/GosubParamStmt.o
 
 NQCOBJ = nqc/nqc.o nqc/SRecord.o nqc/DirList.o nqc/CmdLine.o
 
@@ -150,10 +164,10 @@
 	$(MKDIR) bin
 
 bin/nqc : compiler/parse.cpp $(OBJ)
-	$(CC) -o $@ $(OBJ) $(LIBS)
+	$(CXX) -o $@ $(OBJ) $(LIBS)
 
 bin/mkdata : mkdata/mkdata.cpp nqc/SRecord.cpp
-	$(CC) -o bin/mkdata -Inqc/ -Iplatform/ mkdata/mkdata.cpp nqc/SRecord.cpp
+	$(CXX) -o bin/mkdata -Inqc/ -Iplatform/ mkdata/mkdata.cpp nqc/SRecord.cpp
 
 #
 # clean up stuff
@@ -213,7 +227,7 @@
 # general rule for compiling
 #
 .cpp.o:
-	$(CC) -c $(CFLAGS) $< -o $*.o 
+	$(CXX) -c $(CFLAGS) $< -o $*.o
 
 
 #
@@ -228,7 +242,7 @@
 
 
 #
-# This is used to create a default parser, lexer, and nqh files for later use. 
+# This is used to create a default parser, lexer, and nqh files for later use.
 # You shouldn't need to do this as part of a port.
 #
 DEF_FILES = compiler/parse.cpp compiler/lexer.cpp compiler/rcx1_nqh.h compiler/rcx2_nqh.h

=== debian/changelog ===
nqc (3.1.r6-7) unstable; urgency=medium

  * Corrected install path for appstream metadata to
    /usr/share/metainfo/.
  * Removed template d/README.source.
  * Fixed segfault caused by writing to read only memory segment when
    using Swan target.  (Closes: #848962)
  * Updated Standards-Version from 3.9.8 to 4.0.1.
  * Adjusted fix-errors.h.patch to avoid compiler warning.
  * Added compiler-warnings.patch to avoid some compiler warnings.
  * Added simple autopkgtest script using all the supported compiler
    targets.
  * Changed package Priority from extra to optional to match the
    Debian archive.

 -- Petter Reinholdtsen <pere@debian.org>  Thu, 17 Aug 2017 07:28:29 +0200

nqc (3.1.r6-6) unstable; urgency=medium

  * Fixed typo in udev rule breaking it for everyone (== -> =).
  * Corrected section in d/gbp.conf.

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 19 Oct 2016 08:46:06 +0000

nqc (3.1.r6-5) unstable; urgency=medium

  * Moved package under the new Debian LEGO Team umbrella and publish
    git repo there (Closes: #815075).
  * Added udev marker ID_LEGO_MINDSTORMS in udev rule.
  * Added d/gbp.conf to enforce use of pristine-tar.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 11 Oct 2016 08:02:42 +0000

nqc (3.1.r6-4) unstable; urgency=medium

  * QA upload.
  * Added udev rule to use console user access to the USB device for the
    RCX unit.

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 05 Oct 2016 19:53:13 +0000

nqc (3.1.r6-3) unstable; urgency=medium

  * QA upload.
  * Changed maintainer to Debian QA team as package is orphaned.
  * Updated Standards-Version from 3.9.5 to 3.9.8.
  * Added appstream info announcing support for the Lego Mindstorms RCX.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 17 Sep 2016 09:08:29 +0000

nqc (3.1.r6-2) unstable; urgency=medium

  * repackage after adoprion
  * change maintainer to my self (Closes: #697553)
  * bump standards version to 3.9.5
  * add Build-Depends to dpkg-dev (>= 1.16.1~)
  * delete the debian/dir file
  * change /usr/doc to /usr/share/doc in README.Debian and manpage
  * fix old changelog entry syntax (from 20 Nov 1999 netry)
  * switch changes from previous maintainer to quilt system
  * add link to homepage (Closes: #697227)
  * upload sponsored by Petter Reinholdtsen

 -- Slavko <linux@slavino.sk>  Sat, 01 Feb 2014 16:15:05 +0100

nqc (3.1.r6-1) unstable; urgency=low

  * New upstream release.
  
  * Apply Makefile fix from
    http://launchpadlibrarian.net/8071303/ubuntu_patch.txt.  Thanks to
    Michael Wales <mwales3@gmail.com> for submitting this fix.
  
  * Minor packaging changes to upgrade to Debhelper compatibility level 5.

 -- Ben Pfaff <pfaffben@debian.org>  Wed, 13 Jun 2007 06:07:50 -0700

nqc (2.5.r3-5) unstable; urgency=low

  * compiler/Error.h, compiler/Error.c: Do a more thorough job of tracking
    down the real problem with the fData member.  I think this will really
    fix the FTBFS.  Closes: #287812.

 -- Ben Pfaff <pfaffben@debian.org>  Fri, 18 Aug 2006 10:27:59 -0700

nqc (2.5.r3-4) unstable; urgency=low

  * compiler/Error.h: Change Error's fData member from type `int' to
    `intptr_t', to ensure that it has enough room for a pointer.  Closes:
    #287812.

 -- Ben Pfaff <pfaffben@debian.org>  Tue, 15 Aug 2006 14:42:56 -0700

nqc (2.5.r3-3) unstable; urgency=low

  * Apply patch from Andreas Jochens <aj@andaco.de> to make NQC compile
    under GCC 3.4.  Closes: #265532.

 -- Ben Pfaff <pfaffben@debian.org>  Sat,  4 Sep 2004 14:31:12 -0700

nqc (2.5.r3-2) unstable; urgency=low

  * Use /dev/usb/usblegotower0 as default USB device.  Closes: #233111.

 -- Ben Pfaff <pfaffben@debian.org>  Sat, 21 Feb 2004 19:08:57 -0800

nqc (2.5.r3-1) unstable; urgency=low

  * New upstream release.

  * Updated README.Debian and description to include USB instructions.
    Please let me know if these are incorrect; I don't have a Mindstorms
    set anymore and never had a USB set so I can't test it myself.
  
  * Added header legousbtower.h into new directory rcxlib/LegoUSB to make
    it possible for everything to compile.

 -- Ben Pfaff <pfaffben@debian.org>  Sun, 15 Feb 2004 16:31:38 -0800

nqc (2.5.r1-1) unstable; urgency=low

  * New upstream release.  Closes: #197012.

 -- Ben Pfaff <pfaffben@debian.org>  Tue, 17 Jun 2003 22:38:13 -0700

nqc (2.3.r1-4) unstable; urgency=low

  * Use /dev/rcx as default serial port.  Thanks to Gustavo Laboreiro
    <l11521@alunos.uevora.pt> for reporting this bug.

 -- Ben Pfaff <pfaffben@debian.org>  Sun, 29 Sep 2002 14:22:15 -0700

nqc (2.3.r1-3) unstable; urgency=low

  * Change section from electronics to devel.

 -- Ben Pfaff <blp@cs.stanford.edu>  Thu, 11 Oct 2001 12:12:56 -0700

nqc (2.3.r1-2) unstable; urgency=low

  * Add Build-Depends: on bison, flex.  Closes: #115146.

 -- Ben Pfaff <blp@cs.stanford.edu>  Wed, 10 Oct 2001 18:41:10 -0700

nqc (2.3.r1-1) unstable; urgency=low

  * New upstream version.  Closes: #106397.
  
  * Debian package completely redone.
  
  * No longer includes documentation or examples because there's no
    license on the ones available.  If someone will get Dave Baum to add a
    license then I'll add them back in.

 -- Ben Pfaff <blp@cs.stanford.edu>  Mon,  8 Oct 2001 18:31:58 -0700

nqc (2.0.2-2) unstable; urgency=low

  * New upstream documentation.  Fixes Bug#50669.  Thanks to Jim Studt
    <jim@federated.com> for reporting this.

 -- Ben Pfaff <blp@gnu.org>  Sat, 20 Nov 1999 01:11:32 -0500

nqc (2.0.2-1) unstable; urgency=low

  * New upstream version.
  
  * Migrate to /usr/share/doc.

 -- Ben Pfaff <blp@gnu.org>  Sat, 13 Nov 1999 12:11:51 -0500

nqc (1.3-1) unstable; urgency=low

  * New upstream version.

 -- Ben Pfaff <blp@gnu.org>  Sat, 10 Jul 1999 15:06:21 -0400

nqc (1.0b4-5) unstable; urgency=low

  * Move to section `electronics'.

 -- Ben Pfaff <blp@gnu.org>  Thu, 28 Jan 1999 21:22:42 -0500

nqc (1.0b4-4) unstable; urgency=low

  * Remove -m486 (Bug #31710).



=== debian/control ===
Source: nqc
Section: devel
Priority: optional
Maintainer: Debian LEGO Team <debian-lego-team@lists.alioth.debian.org>
Uploaders:
 Petter Reinholdtsen <pere@debian.org>
Build-Depends: debhelper (>= 9.0.0), dpkg-dev (>= 1.16.1~), bison, flex
Standards-Version: 4.0.1
Homepage: http://bricxcc.sourceforge.net/nqc/
Vcs-Git: git://anonscm.debian.org/debian-lego/nqc.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-lego/nqc.git

Package: nqc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Not Quite C compiler for LEGO Mindstorms RCX
 The LEGO Mindstorms RCX is a Hitachi microcontroller embedded into a
 LEGO brick.  This package lets you write programs in a C-like
 language and download them to your RCX using the serial or USB
 infrared tower included with the RCX.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)

PACKAGE = $(shell dh_listpackages)
TMP     = $(CURDIR)/debian/$(PACKAGE)

%:
	dh $@ 

override_dh_auto_build:
	echo $(CFLAGS)
	$(MAKE) DEFAULT_SERIAL_NAME='"/dev/rcx"'

override_dh_auto_install:

override_dh_installman:
	dh_installman
	mv $(TMP)/usr/share/man/man1/nqc-man-2.1r1-0.1 $(TMP)/usr/share/man/man1/nqc.1

override_dh_installexamples:
	dh_installexamples
	chmod -x $(TMP)/usr/share/doc/nqc/examples/test.nqc

=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

# <Webpage URL> <string match>
opts=uversionmangle=s/-/./ \
http://bricxcc.sourceforge.net/nqc/release/ nqc-(\d.*)\.tgz

## nqc 4.0.1+dfsg

=== Makefile ===
# Makefile for nqc
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.
#
# The Initial Developer of this code is David Baum.
# Portions created by David Baum are Copyright (C) 1999 David Baum.
# All Rights Reserved.
#
# Portions created by John Hansen are Copyright (C) 2005 John Hansen.
# All Rights Reserved.
#
#   original author:
#		Dave Baum <dbaum@enteract.com>
#
#   other contributors:
#		Rodd Zurcher <rbz@enteract.com>
#		Patrick Nadeau <pnadeau@wave.home.com>
#		Jonathan W. Miner <jminer@fcmail.com>
#		Matthew Sheets
#		Maeh W. <maehw@posteo.de>
#
#
.SUFFIXES: .cpp .c

#
# Pick your C++ compiler.
#
CXX ?= ${CXX}
# CXX ?= g++
ifeq ($(origin CXX_FOR_BUILD), undefined)
  CXX_FOR_BUILD := $(CXX)
endif

#
# Pick your YACC processor
#
YACC ?= bison -y
# YACC ?= yacc

#
# Define the FLEX processor
# NOTE: lex will not work
#
FLEX ?= flex -Cfe

#
# Link in any necessary C++ libraries
#
LIBS ?= -lstdc++

#
# Toolchain for h8300-hitachi-coff
#
H8300_TOOLPREFIX ?= h8300-hitachi-coff-
H8300_LD ?= $(H8300_TOOLPREFIX)ld
H8300_AS ?= $(H8300_TOOLPREFIX)as
H8300_OBJDUMP ?= $(H8300_TOOLPREFIX)objdump

H8300_FOUND := $(shell $(H8300_AS) --version >/dev/null 2>&1 && echo found)
ifneq ($(H8300_FOUND), found)
$(warning h8300-hitachi-coff toolchain not found, using pre-built files)
endif

# installation defaults

# Normalize for path prepending (remove any trailing slash)
# Cannot use \$(realpath \$(dir)) since this path might not exist
ifneq ($(DESTDIR),)
DESTDIR := $(patsubst %/,%,$(DESTDIR))
endif

ifneq ($(prefix),)
prefix := $(patsubst %/,%,$(prefix))
endif

prefix ?= /opt/stow/nqc
exec_prefix ?= $(prefix)
bindir ?= $(exec_prefix)/bin
datarootdir ?= $(prefix)/share
mandir ?= $(datarootdir)/man
man1dir ?= $(mandir)/man1
manext ?= 1

# other commands
CP ?= cp -f
MKDIR ?= mkdir -p
MV ?= mv -f
RM ?= rm -f
DOXYGEN ?= doxygen

# Common local include directories
INCLUDE_DIRS = platform rcxlib nqc compiler $(GEN_DIR)/rcxlib $(GEN_DIR)/compiler
INCLUDES = $(addprefix -I, $(INCLUDE_DIRS))

# Common compiler flags
CFLAGS += $(INCLUDES) -Wall
CFLAGS_FOR_BUILD += $(INCLUDES) -Wall

# Default configuration values
OBJ_SUBDIR_NAME ?= obj
H8300_SUBDIR_NAME ?= h8300
UTILS_SUBDIR_NAME ?= utils
EXEC_SUBDIR_NAME ?= bin
GEN_SUBDIR_NAME ?= generated

BUILD_DIR ?= build
OBJ_DIR ?= $(BUILD_DIR)/$(OBJ_SUBDIR_NAME)
H8300_DIR ?= $(BUILD_DIR)/$(H8300_SUBDIR_NAME)
EXEC_DIR ?= $(BUILD_DIR)/$(EXEC_SUBDIR_NAME)
UTILS_DIR ?= $(BUILD_DIR)/$(UTILS_SUBDIR_NAME)
GEN_DIR ?= $(BUILD_DIR)/$(GEN_SUBDIR_NAME)


# Default to NO USB tower support and NO TCP support.
# USB and TCP support can be enabled
# via the platform-specific settings below.
USBOBJ ?= RCX_USBTowerPipe_none
TCPOBJ ?= RCX_TcpPipe_none

#
# Platform specific settings
#
OSTYPE := $(strip $(shell uname -s))

ifneq (,$(strip $(findstring $(TARGETTYPE), JS-WebAssembly)))
	# WebAssembly embedded in JavaScript
	CXX = emcc
	OBJ_SUBDIR_NAME = wobj
	EXEC_SUBDIR_NAME = js-wasm
	EXEC_EXT = .js

	# Emscripten optimization flags documentation
	# - https://emscripten.org/docs/optimizing/Optimizing-Code.html#optimizing-code
	# - https://emscripten.org/docs/tools_reference/emcc.html#emcc-compiler-optimization-options
	CFLAGS += -Os
	
	# Documentation for various Emscripten flags
	# - Full List:    https://github.com/emscripten-core/emscripten/blob/main/src/settings.js
	# - Modularize:   https://emscripten.org/docs/getting_started/FAQ.html#can-i-use-multiple-emscripten-compiled-programs-on-one-web-page
	# - Environment:  https://emscripten.org/docs/getting_started/FAQ.html#can-i-build-javascript-that-only-runs-on-the-web
	# - Single File:  https://emscripten.org/docs/compiling/Building-Projects.html?highlight=SINGLE_FILE#emscripten-linker-output-files
	# - Target JavaScript instead of WASM:  -s WASM=0
	CFLAGS_EXEC += --shell-file ./emscripten/webnqc_shell.html -s EXPORT_NAME=createWebNqc  -s EXPORTED_RUNTIME_METHODS='["callMain","FS"]' \
		-s INVOKE_RUN=false  -s MODULARIZE=1  -s ENVIRONMENT=web  -s SINGLE_FILE
else
ifneq (,$(strip $(findstring $(OSTYPE), Darwin)))
	# Mac OS X
	LIBS += -framework IOKit -framework CoreFoundation
	USBOBJ = RCX_USBTowerPipe_osx
	CXX = c++
	CFLAGS += -O3 -std=c++11 -Wno-deprecated-register
else
ifneq (,$(strip $(findstring $(OSTYPE), Linux)))
	# Linux
	USBOBJ = RCX_USBTowerPipe_linux
	TCPOBJ = RCX_TcpPipe_linux
	DEFAULT_SERIAL_NAME ?= "/dev/ttyS0"
	# Timeout value is 200 in kernel driver module legousbtower.c
	LEGO_TOWER_SET_READ_TIMEOUT ?= 200
	CFLAGS += -DLEGO_TOWER_SET_READ_TIMEOUT='$(LEGO_TOWER_SET_READ_TIMEOUT)' -Wno-deprecated
else
ifneq (,$(findstring $(OSTYPE), SunOS))
	# Solaris
	CFLAGS += -DSOLARIS
else
ifneq (,$(strip $(findstring $(OSTYPE), FreeBSD)))
	# FreeBSD
	USBOBJ = RCX_USBTowerPipe_fbsd
	DEFAULT_SERIAL_NAME?= "/dev/cuad0"
	CFLAGS += -Wno-deprecated
else
ifneq (,$(strip $(findstring $(OSTYPE), OpenBSD)))
	# OpenBSD i386
	DEFAULT_SERIAL_NAME ?= "/dev/cua00"
	CFLAGS += -O2 -std=gnu++98 -pipe
else
	# default Unix build without USB support
	CFLAGS += -O2
endif
endif
endif
endif
endif
endif

CXX:=$(TOOLPREFIX)$(CXX)

#
# If the serial port is explicitly set, use it.
#
ifneq ($(strip $(DEFAULT_SERIAL_NAME)),)
	CFLAGS += -DDEFAULT_SERIAL_NAME='$(DEFAULT_SERIAL_NAME)'
endif

DEFAULT_USB_NAME ?= "/dev/usb/legousbtower0"
CFLAGS += -DDEFAULT_USB_NAME='$(DEFAULT_USB_NAME)'

DEFAULT_DEVICE_NAME ?= "usb"
CFLAGS += -DDEFAULT_DEVICE_NAME='$(DEFAULT_DEVICE_NAME)'

#
# Debug builds for most Clang/GCC environments.
# This implies -DDEBUG_TIMEOUT
#
#CFLAGS += -DDEBUG -DPDEBUG -g -O0

#
# Object files
#
OBJ = $(addprefix $(OBJ_DIR)/, $(NQCOBJ) $(COBJ) $(RCXOBJ) $(POBJ))

RCXOBJS = RCX_Cmd RCX_Disasm RCX_Image RCX_Link RCX_Log \
	RCX_Target RCX_Pipe RCX_PipeTransport RCX_Transport \
	RCX_SpyboticsLinker RCX_SerialPipe \
	$(USBOBJ) $(TCPOBJ)
RCXOBJ = $(addprefix rcxlib/, $(addsuffix .o, $(RCXOBJS)))

POBJS = PStream PSerial_unix PHashTable PListS PDebug StrlUtil
POBJ = $(addprefix platform/, $(addsuffix .o, $(POBJS)))

COBJS = AsmStmt AssignStmt BlockStmt Bytecode Conditional \
	CondParser DoStmt Expansion Fragment IfStmt JumpStmt \
	lexer Macro parse PreProc Program RepeatStmt \
	AssignMathStmt Stmt Symbol TaskStmt WhileStmt Error \
	AutoFree parse_util Expr GosubStmt Scope InlineStmt \
	CallStmt CaseStmt SwitchStmt MonitorStmt AcquireStmt \
	DeclareStmt ScopeStmt ForStmt CatchStmt LabelStmt \
	GotoStmt Compiler Buffer Mapping FunctionDef ExprStmt \
	AtomExpr IncDecExpr BinaryExpr UnaryExpr ValueExpr \
	TypeExpr ModExpr EventSrcExpr SensorExpr ArrayExpr \
	TaskIdExpr RelExpr LogicalExpr NegateExpr IndirectExpr \
	NodeExpr ShiftExpr TernaryExpr VarAllocator VarTranslator \
	Resource AddrOfExpr DerefExpr GosubParamStmt
COBJ = $(addprefix compiler/, $(addsuffix .o, $(COBJS)))

NQCOBJS = nqc SRecord DirList CmdLine
NQCOBJ = $(addprefix nqc/, $(addsuffix .o, $(NQCOBJS)))


all: info exec emscripten-emmake default-check-fastdl

exec: info $(EXEC_DIR)/nqc$(EXEC_EXT)

$(EXEC_DIR)/nqc$(EXEC_EXT): compiler/parse.cpp $(OBJ)
	$(MKDIR) $(dir $@)
	$(CXX) $(CFLAGS) $(CFLAGS_EXEC) -o $@ $(OBJ) $(LIBS) $(LDFLAGS)

#
# Emscripten build for WebAssembly
#
emscripten-emmake:
	emmake make exec TARGETTYPE=JS-WebAssembly

#
# general rule for compiling
#
$(OBJ_DIR)/%.o: %.cpp | compiler/parse.cpp
	$(MKDIR) $(dir $@)
	$(CXX) -c $(CFLAGS) $< -o $@

#
# clean up stuff
#
clean: clean-parser clean-lexer clean-obj clean-build

clean-build:
	-$(RM) -r $(BUILD_DIR)/*

clean-obj:
	-$(RM) */*.o

clean-parser:
	-$(RM) compiler/parse.cpp compiler/parse.tab.h

clean-lexer:
	-$(RM) compiler/lexer.cpp

#
# create the parser files (parse.cpp and parse.tab.h)
#
compiler/parse.tab.h: compiler/parse.cpp
compiler/parse.cpp: compiler/parse.y
	cd compiler ; \
	$(YACC) -d parse.y ; \
	$(MV) y.tab.c parse.cpp ; \
	$(MV) y.tab.h parse.tab.h

#
# create the lexer file (lexer.cpp)
#
compiler/lexer.cpp: compiler/lex.l
	cd compiler ; \
	$(FLEX) lex.l

#
# mkdata utility
#
$(UTILS_DIR)/mkdata: mkdata/mkdata.cpp nqc/SRecord.cpp
	$(MKDIR) $(dir $@)
	$(CXX_FOR_BUILD) $(CFLAGS_FOR_BUILD) $(LDFLAGS_FOR_BUILD) -o $@ $^

#
# NQH files
#
nqh: $(GEN_DIR)/compiler/rcx1_nqh.h $(GEN_DIR)/compiler/rcx2_nqh.h

$(GEN_DIR)/compiler/%_nqh.h: compiler/%.nqh $(UTILS_DIR)/mkdata
	$(MKDIR) $(dir $@)
	$(UTILS_DIR)/mkdata $< $@ $*_nqh

$(OBJ_DIR)/compiler/Compiler.o: $(GEN_DIR)/compiler/rcx1_nqh.h $(GEN_DIR)/compiler/rcx2_nqh.h

#
# rcxnub.h & rcxnub_odd.h
#
nub: $(GEN_DIR)/rcxlib/rcxnub.h $(GEN_DIR)/rcxlib/rcxnub_odd.h

$(GEN_DIR)/rcxlib/rcxnub.h: $(H8300_DIR)/rcxlib/fastdl.srec $(UTILS_DIR)/mkdata
	$(MKDIR) $(dir $@)
	$(UTILS_DIR)/mkdata -s $< $@ rcxnub

$(GEN_DIR)/rcxlib/rcxnub_odd.h: $(H8300_DIR)/rcxlib/fastdl_odd.srec $(UTILS_DIR)/mkdata
	$(MKDIR) $(dir $@)
	$(UTILS_DIR)/mkdata -s $< $@ rcxnub_odd

$(OBJ_DIR)/rcxlib/RCX_Link.o: $(GEN_DIR)/rcxlib/rcxnub.h $(GEN_DIR)/rcxlib/rcxnub_odd.h

#
# fastdl.srec & fastdl_odd.srec
#
FASTDL = fastdl fastdl_odd
fastdl: $(FASTDL:%=$(H8300_DIR)/rcxlib/%.srec)

ifeq ($(H8300_FOUND), found)

$(H8300_DIR)/rcxlib/fastdl.o: rcxlib/fastdl.s
	$(MKDIR) $(dir $@)
	$(H8300_AS) -o $@ $<

$(H8300_DIR)/rcxlib/fastdl_odd.o: rcxlib/fastdl.s
	$(MKDIR) $(dir $@)
	$(H8300_AS) --defsym odd=1 -o $@ $<

$(H8300_DIR)/rcxlib/%.srec: $(H8300_DIR)/rcxlib/%.o
	$(MKDIR) $(dir $@)
	$(H8300_LD) -Ttext 0x8000 -e __start --oformat srec -o $@ $<
	chmod -x $@

dis: $(FASTDL:%=$(H8300_DIR)/rcxlib/%.dis.s)
%.dis.s: %.srec
	$(H8300_OBJDUMP) -m h8300 -D $< > $@ || rm $@

default-snapshot-fastdl: $(FASTDL:%=$(H8300_DIR)/rcxlib/%.srec)
	$(MKDIR) default
	$(CP) $(FASTDL:%=$(H8300_DIR)/rcxlib/%.srec) default

default-check-fastdl: $(FASTDL:%=$(H8300_DIR)/rcxlib/%.srec.check)

$(H8300_DIR)/rcxlib/%.srec.check: default/%.srec $(H8300_DIR)/rcxlib/%.srec
	@echo "Please run make default-snapshot-fastdl and commit if this fail:"
	diff -u $^
	touch $@

else

$(H8300_DIR)/rcxlib/%.srec: default/%.srec
	$(MKDIR) $(dir $@)
	$(CP) $< $@

default-snapshot-fastdl:
	@echo "no h8300-hitachi-coff toolchain"
	false

default-check-fastdl:
	@echo "no h8300-hitachi-coff toolchain, cannot check pre-built files"

endif

#
# Use these targets to use the default parser/lexer files.  This is handy if
# your system does not have a suitable flex and/or yacc tool.
#
default-parser:
	$(CP) default/parse.cpp default/parse.tab.h nqc

default-lexer:
	$(CP) default/lexer.cpp nqc

#
# This is used to create a default parser and lexer files for later use.
# You shouldn't need to do this as part of a port.
#
DEF_FILES = compiler/parse.cpp compiler/parse.tab.h \
	    compiler/lexer.cpp
default-snapshot: default-snapshot-fastdl $(DEF_FILES)
	$(MKDIR) default
	$(CP) $(DEF_FILES) default


#
# Generate API docs. Not part of a port.
#
docs:
	@$(DOXYGEN) Doxyfile

#
# Installation of binary and man page
#
install: info exec
	-mkdir -p $(DESTDIR)$(bindir)
	cp -r $(EXEC_DIR)/* $(DESTDIR)$(bindir)
	-mkdir -p $(DESTDIR)$(man1dir)
	cp nqc-man.man $(DESTDIR)$(man1dir)/nqc.$(manext)


#
# Print some info about the environment
#
info:
	@echo Building for: $(OSTYPE)
	@echo DESTDIR=$(DESTDIR)
	@echo prefix=$(prefix)
	@echo exec_prefix=$(exec_prefix)
	@echo bindir=$(bindir)
	@echo datarootdir=$(datarootdir)
	@echo mandir=$(mandir)
	@echo man1dir=$(man1dir)
	@echo manext=$(manext)
	@echo STOW_TARGET=$(STOW_TARGET)
	@echo STOW_DIR=$(STOW_DIR)
	@echo STOW_PACKAGE=$(STOW_PACKAGE)
	@echo STOW_STANDARD_ARGS=$(STOW_STANDARD_ARGS)
	@echo STOW_PREREQ_TARGET=$(STOW_PREREQ_TARGET)
	@echo BUILD_DIR=$(BUILD_DIR)
	@echo OBJ_DIR=$(OBJ_DIR)
	@echo H8300_DIR=$(H8300_DIR)
	@echo UTILS_DIR=$(UTILS_DIR)
	@echo GEN_DIR=$(GEN_DIR)
	@echo EXEC_DIR=$(EXEC_DIR)
	@echo EXEC_EXT=$(EXEC_EXT)
	@echo USBOBJ=$(USBOBJ)
	@echo TCPOBJ=$(TCPOBJ)
	@echo YACC=$(YACC)
	@echo FLEX=$(FLEX)
	@echo LIBS=$(LIBS)
	@echo CXX=$(CXX)
	@echo CFLAGS=$(CFLAGS)
	@echo CFLAGS_EXEC=$(CFLAGS_EXEC)
	@echo OBJ=$(OBJ)
	@echo H8300_TOOLPREFIX=$(H8300_TOOLPREFIX)

=== debian/changelog ===
nqc (4.0.1+dfsg-1) unstable; urgency=medium

  * Change upstream to BrickBot NQC project.
  * New upstream version 4.0.1+dfsg:
    - Update debian/copyright.
    - Refresh patches, remove patches applied upstream or no longer needed.
    - Update build.
    - This fixes the build dependencies problem (Closes: #1105494).
  * Drop the Debian specific default serial port path /dev/rcx.
    NQC now defaults to using USB which is more common on today computers.
    If you use a serial port, give the actual serial port path directly.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Thu, 14 Aug 2025 08:45:38 +0200

nqc (3.1.r6-13) unstable; urgency=medium

  * debian/README.Debian: replace dead links.
  * Drop dpkg-dev build dependency, which is a build-essential.
  * Upgrade to HTTPS for Homepage, copyright, watch and changelog.
  * Add 1080-fix-manpage-url.patch, replacing or removing dead links in manual
    page.
  * Enable Salsa CI using default template.
  * Update debian/copyright for debian part.
  * Use CXXFLAGS and CPPFLAGS to define CFLAGS, which is the only one used by
    upstream Makefile.
  * Add blhc ignore-line-regexp for bin/mkdata which is not installed.
  * Update Standards-Version to 4.7.2, no change needed.
  * Add myself as an uploader.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Fri, 04 Apr 2025 00:55:29 +0200

nqc (3.1.r6-12) unstable; urgency=medium

  * Correct file name for Appstream metainfo XML content.
  * Set field Upstream-Contact in debian/copyright.
  * Remove obsolete field Contact from debian/upstream/metadata
    (already present in machine-readable debian/copyright).
  * Update standards version to 4.7.0, no changes needed.

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 14 Aug 2024 08:53:31 +0200

nqc (3.1.r6-11) unstable; urgency=medium

  * Removed unused d/lintian-overrides.
  * Adjusted d/rules to build hardened binaries.

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 06 Oct 2021 08:23:19 +0200

nqc (3.1.r6-10) unstable; urgency=medium

  * Added 1070-typos-code.patch to fix some code typos discovered by Lintian.
  * Switched d/watch to version 4.
  * Switched appstream metadata license back to MIT and adjusted d/copyright.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 03 Oct 2021 08:15:43 +0200

nqc (3.1.r6-9) unstable; urgency=medium

  * Fixed description typo in apply-rcx_changes.patch.
  * Renamed patches according to wanted patch naming scheme.
  * Added upstream contact emali to upstream metadata.
  * Adjusted license info in appstream metadata file to match d/copyright.

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 29 Sep 2021 18:17:11 +0200

nqc (3.1.r6-8) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use secure copyright file specification URI.
  * Bump debhelper from deprecated 9 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Archive, Repository.
  * Update Vcs-* headers to use salsa repository.
  * Replace use of deprecated $ADTTMP with $AUTOPKGTEST_TMP.

  [ Petter Reinholdtsen ]
  * Updated Standards-Version from 4.0.1 to 4.6.0.
  * Switch appstream metadata ID to reverse domain-name.
  * Mark package to not need root access during build.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 26 Sep 2021 07:22:28 +0200

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,14 @@
 Priority: optional
 Maintainer: Debian LEGO Team <debian-lego-team@lists.alioth.debian.org>
 Uploaders:
- Petter Reinholdtsen <pere@debian.org>
-Build-Depends: debhelper (>= 9.0.0), dpkg-dev (>= 1.16.1~), bison, flex
-Standards-Version: 4.0.1
-Homepage: http://bricxcc.sourceforge.net/nqc/
-Vcs-Git: git://anonscm.debian.org/debian-lego/nqc.git
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-lego/nqc.git
+ Petter Reinholdtsen <pere@debian.org>,
+ Nicolas Schodet <nico@ni.fr.eu.org>,
+Build-Depends: debhelper-compat (= 13), bison, flex, binutils-h8300-hms
+Standards-Version: 4.7.2
+Homepage: https://bricxcc.sourceforge.net/nqc/
+Vcs-Git: https://salsa.debian.org/debian-lego-team/nqc.git
+Vcs-Browser: https://salsa.debian.org/debian-lego-team/nqc
+Rules-Requires-Root: no
 
 Package: nqc
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
# Upstream Makefile uses CFLAGS instead of CXXFLAGS and ignores CPPFLAGS.
CFLAGS = $(CXXFLAGS) $(CPPFLAGS)
CFLAGS_FOR_BUILD = $(CXXFLAGS_FOR_BUILD) $(CPPFLAGS_FOR_BUILD)

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- exec

override_dh_auto_install:
	dh_auto_install -- prefix=/usr

override_dh_installexamples:
	dh_installexamples

## nqc 4.1.0%2Bdfsg

=== debian/changelog ===
nqc (4.1.0+dfsg-1) unstable; urgency=medium

  * New upstream version 4.1.0+dfsg:
    - Exclude non-DFSG files, or files with unknown license.
    - Update debian/copyright.
    - Add build dependency to pandoc and rsync for documentation.
    - Update build.
  * Use a fixed BUILD_DIR value.
  * Add remove-trackers.patch, removing trackers in HTML files.
  * Do not install archive of original documentation and large pictures.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Tue, 14 Oct 2025 22:20:04 +0200
